function [k theta  rhotd omegatd scaling] = YU(trce,trceTime)

%Special parameter fo the algorithm
timeInt=1;

%Infer lambda from trceTime
diff=[];
for i=1:min(2000,length(trceTime))-1
    diff=[diff (trceTime(i+1)-trceTime(i))];
end
si = mean(diff);
lambda=1/si;

%Initialize parameter values
ko=[1 1];
thetao=[1 100];
[L NL]=LNL(trce);
if (var(L)>0)
    ko(1)=mean(L)^2/(var(L));
end
if (var(NL)>0)
    ko(2)=mean(NL)^2/(var(NL));
end
thetao=[mean(L)/(lambda*ko(1)) mean(NL)/(lambda*ko(2))];


%%%% Computing observation array for input into the hsmm algorithm
maxTime=trceTime(length(trceTime))-trceTime(1);
timeArray = trceTime(1) + [0:timeInt:(maxTime+timeInt)];

binArray=(2)*ones(1,length(timeArray)); %%% 2 is miss, 0 is loss, 1 is good
for t=2:length(timeArray)
    tempk=find((trceTime>=timeArray(t-1))&(trceTime<timeArray(t)));
    if length(tempk)>0
        binArray(t) = trce(tempk(1));
    end
end

O = binArray+1;
PAI=[0.1; 0.9];
A = ones(2,2);
for r=1:2
    A(r,r)=0;
end

D=4000;
P=zeros(2,D);
for i=1:2
    for j=1:D
        P(i,j) =  distF(thetao(i),ko(i),j);
    end
end
%B=[1-exp(-lambda) 0 exp(-lambda);0 1-exp(-lambda) exp(-lambda)]; %%% 3 is unobsrved; 1 is loss, 2 is good
B=[1 0 1;0 1 1];
IterationNo=60;


%%% Calling the HSMM algorithm
[PAI,A,B,P_est,Qest,lkh] = hsmm_new(PAI,A,B,P,O,IterationNo);

%%%% Process the data to get the parameters
meanEst=[0 0];
meanS=[0 0];
varianceEst=[0 0];
for i=1:2
    for j=1:D
        meanEst(i) =meanEst(i)+(j)*P_est(i,j);
        meanS(i)=meanS(i)+(j)^2*P_est(i,j);
        
    end
    variance(i)= meanS(i) - meanEst(i)*meanEst(i);
end
theta =variance./meanEst;
k=meanEst./theta;
